std::unordered_multimap::erase(3)

NAME
std::unordered_multimap::erase - std::unordered_multimap::erase

Synopsis
   iterator erase( iterator pos ); (1) (since C++11)
   iterator erase( const_iterator pos ); (2) (since C++11)
   iterator erase( const_iterator first, const_iterator last ); (3) (since C++11)
   size_type erase( const Key& key ); (4) (since C++11)
   template< class K > (5) (since C++23)
   size_type erase( K&& x );
   Removes specified elements from the container. The order of the remaining elements
   is preserved. (This makes it possible to erase individual elements while iterating
   through the container.)
   1,2) Removes the element at pos.
   3) Removes the elements in the range [first, last), which must be a valid range in
   *this.
   4) Removes all elements with the key equivalent to key.
   5) Removes all elements with key that compares equivalent to the value x. This
   overload participates in overload resolution only if Hash::is_transparent and
   KeyEqual::is_transparent are valid and each denotes a type, and neither iterator nor
   const_iterator is implicitly convertible from K. This assumes that such Hash is
   callable with both K and Key type, and that the KeyEqual is transparent, which,
   together, allows calling this function without constructing an instance of Key.
   References and iterators to the erased elements are invalidated. Other iterators and
   references are not invalidated.
   The iterator pos must be valid and dereferenceable. Thus the end() iterator (which
   is valid, but is not dereferenceable) cannot be used as a value for pos.

Parameters
   pos - iterator to the element to remove
   first, last - range of elements to remove
   key - key value of the elements to remove
   x - a value of any type that can be transparently compared with a key
                 denoting the elements to remove

Return value
   1-3) Iterator following the last removed element.
   4) Number of elements removed.
   5) Number of elements removed.

Exceptions
   1-3) Throws nothing.
   4,5) Any exceptions thrown by the Hash and KeyEqual object.

Complexity
   Given an instance c of unordered_multimap:
   1,2) Average case: constant, worst case: c.size().
   3) Average case: std::distance(first, last), worst case: c.size().
   4) Average case: c.count(key), worst case: c.size().
   5) Average case: c.count(x), worst case: c.size().

Notes
               Feature-test macro Value Std Feature
                        Heterogeneous erasure in
                        associative containers
   __cpp_lib_associative_heterogeneous_erasure 202110L (C++23) and unordered
                        associative containers;
                        overload (5)

Example
// Run this code
 #include <unordered_map>
 #include <iostream>
 int main()
 {
     std::unordered_multimap<int, std::string> c =
     {
         {1, "one"}, {2, "two"}, {3, "three"},
         {4, "four"}, {5, "five"}, {6, "six"}
     };
     // erase all odd numbers from c
     for (auto it = c.begin(); it != c.end();)
     {
         if (it->first % 2 != 0)
             it = c.erase(it);
         else
             ++it;
     }
     for (auto& p : c)
         std::cout << p.second << ' ';
     std::cout << '\n';
 }

Possible output:
 two four six
  Defect reports
   The following behavior-changing defect reports were applied retroactively to
   previously published C++ standards.
      DR Applied to Behavior as published Correct behavior
   LWG 2059 C++11 there was ambiguity for overload (2) added overload (1)
                       the order of non-equivalent elements
   LWG 2356 C++11 that are required to be preserved
                       not erased was not guaranteed to be
                       preserved

See also
   clear clears the contents
         (public member function)